/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Uwaki;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractDemandBehavior
*/
public abstract class AbstractDemandBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForTime =
			factory.createCompositeState("WaitingForTime");
		CompositeState waitingForReply =
			factory.createCompositeState("WaitingForReply");
		CompositeState waitingForPhone =
			factory.createCompositeState("WaitingForPhone");
		CompositeState waitingForReply1 =
			factory.createCompositeState("WaitingForReply");
		CompositeState waitingHisReaction =
			factory.createCompositeState("WaitingHisReaction");

		//actions
		Action askingShowAction = new Action() {
			public void doAction() {
				askingShowAction();
			}
			public String toString() {
				return "askingShowAction";
			}
		};
		Action doubtingAction = new Action() {
			public void doAction() {
				doubtingAction();
			}
			public String toString() {
				return "doubtingAction";
			}
		};
		Action askingWhoAction = new Action() {
			public void doAction() {
				askingWhoAction();
			}
			public String toString() {
				return "askingWhoAction";
			}
		};
		Action throwingKnifeAction = new Action() {
			public void doAction() {
				throwingKnifeAction();
			}
			public String toString() {
				return "throwingKnifeAction";
			}
		};
		Action receivingPhoneAction = new Action() {
			public void doAction() {
				receivingPhoneAction();
			}
			public String toString() {
				return "receivingPhoneAction";
			}
		};

		//guard-conditions
		GuardCondition isPhoneGoods = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isPhoneGoods(e);
			}
		};

		//transitions
		Transition transitionWaitingForPhoneToWaitingForReply =
			factory.createTransition();
		Transition transitionWaitingForReplyToWaitingHisReaction =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForTime =
			factory.createTransition();
		Transition transitionWaitingForReplyToWaitingForPhone =
			factory.createTransition();
		Transition transitionWaitingForTimeToWaitingForReply =
			factory.createTransition();
		Transition transitionWaitingHisReactionToWaitingForTime =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForTime);
		this.addState(waitingForReply);
		this.addState(waitingForPhone);
		this.addState(waitingForReply1);
		this.addState(waitingHisReaction);

		//transitions setting
		transitionWaitingForPhoneToWaitingForReply.setEvent(ChannelEvent.class);
		transitionWaitingForPhoneToWaitingForReply.addAction(doubtingAction);
		transitionWaitingForReplyToWaitingHisReaction.setEvent(
			ChannelEvent.class);
		transitionWaitingForReplyToWaitingHisReaction.addAction(
			throwingKnifeAction);
		transitionWaitingForReplyToWaitingForPhone.setEvent(ChannelEvent.class);
		transitionWaitingForReplyToWaitingForPhone.addAction(askingShowAction);
		transitionWaitingForTimeToWaitingForReply.setEvent(TimeEvent.class);
		transitionWaitingForTimeToWaitingForReply.addAction(askingWhoAction);
		transitionWaitingHisReactionToWaitingForTime.setEvent(
			ChannelEvent.class);
		transitionWaitingHisReactionToWaitingForTime.setGuardCondition(
			isPhoneGoods);
		transitionWaitingHisReactionToWaitingForTime.addAction(
			receivingPhoneAction);

		//connection of transitions
		transitionWaitingForPhoneToWaitingForReply.setSourceState(
			waitingForPhone);
		transitionWaitingForPhoneToWaitingForReply.setTargetState(
			waitingForReply1);
		transitionWaitingForReplyToWaitingHisReaction.setSourceState(
			waitingForReply1);
		transitionWaitingForReplyToWaitingHisReaction.setTargetState(
			waitingHisReaction);
		transitionInitialStateToWaitingForTime.setSourceState(initialState);
		transitionInitialStateToWaitingForTime.setTargetState(waitingForTime);
		transitionWaitingForReplyToWaitingForPhone.setSourceState(
			waitingForReply);
		transitionWaitingForReplyToWaitingForPhone.setTargetState(
			waitingForPhone);
		transitionWaitingForTimeToWaitingForReply.setSourceState(
			waitingForTime);
		transitionWaitingForTimeToWaitingForReply.setTargetState(
			waitingForReply);
		transitionWaitingHisReactionToWaitingForTime.setSourceState(
			waitingHisReaction);
		transitionWaitingHisReactionToWaitingForTime.setTargetState(
			waitingForTime);

	}

	/**
	*askingShowAction
	*/
	protected abstract void askingShowAction();
	/**
	*doubtingAction
	*/
	protected abstract void doubtingAction();
	/**
	*askingWhoAction
	*/
	protected abstract void askingWhoAction();
	/**
	*throwingKnifeAction
	*/
	protected abstract void throwingKnifeAction();
	/**
	*receivingPhoneAction
	*/
	protected abstract void receivingPhoneAction();
	/**
	*isPhoneGoods
	*/
	protected abstract boolean isPhoneGoods(Event e);
}
