/*
 * Created on 2004/06/01
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Uwaki;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.behavior.Action;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractExcuseBehavior
*/
public abstract class AbstractExcuseBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState sendingMail =
			factory.createCompositeState("SendingMail");
		CompositeState stopMailing =
			factory.createCompositeState("StopMailing");
		CompositeState beInTrouble =
			factory.createCompositeState("BeInTrouble");
		CompositeState beInDanger = factory.createCompositeState("BeInDanger");

		//actions
		Action replyAction = new Action() {
			public void doAction() {
				replyAction();
			}
			public String toString() {
				return "replyAction";
			}
		};
		Action denyingAction = new Action() {
			public void doAction() {
				denyingAction();
			}
			public String toString() {
				return "denyingAction";
			}
		};
		Action throwingPhoneAction = new Action() {
			public void doAction() {
				throwingPhoneAction();
			}
			public String toString() {
				return "throwingPhoneAction";
			}
		};
		Action receivingKnifeAction = new Action() {
			public void doAction() {
				receivingKnifeAction();
			}
			public String toString() {
				return "receivingKnifeAction";
			}
		};
		Action rejectingAction = new Action() {
			public void doAction() {
				rejectingAction();
			}
			public String toString() {
				return "rejectingAction";
			}
		};

		//guard-conditions
		GuardCondition isKnifeGoods = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isKnifeGoods(e);
			}
		};

		//transitions
		Transition transitionStopMailingToBeInTrouble =
			factory.createTransition();
		Transition transitionInitialStateToSendingMail =
			factory.createTransition();
		Transition transitionBeInDangerToSendingMail =
			factory.createTransition();
		Transition transitionBeInTroubleToBeInDanger =
			factory.createTransition();
		Transition transitionSendingMailToStopMailing =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(sendingMail);
		this.addState(stopMailing);
		this.addState(beInTrouble);
		this.addState(beInDanger);

		//transitions setting
		transitionStopMailingToBeInTrouble.setEvent(ChannelEvent.class);
		transitionStopMailingToBeInTrouble.addAction(rejectingAction);
		transitionBeInDangerToSendingMail.setEvent(ChannelEvent.class);
		transitionBeInDangerToSendingMail.setGuardCondition(isKnifeGoods);
		transitionBeInDangerToSendingMail.addAction(receivingKnifeAction);
		transitionBeInDangerToSendingMail.addAction(throwingPhoneAction);
		transitionBeInTroubleToBeInDanger.setEvent(ChannelEvent.class);
		transitionBeInTroubleToBeInDanger.addAction(denyingAction);
		transitionSendingMailToStopMailing.setEvent(ChannelEvent.class);
		transitionSendingMailToStopMailing.addAction(replyAction);

		//connection of transitions
		transitionStopMailingToBeInTrouble.setSourceState(stopMailing);
		transitionStopMailingToBeInTrouble.setTargetState(beInTrouble);
		transitionInitialStateToSendingMail.setSourceState(initialState);
		transitionInitialStateToSendingMail.setTargetState(sendingMail);
		transitionBeInDangerToSendingMail.setSourceState(beInDanger);
		transitionBeInDangerToSendingMail.setTargetState(sendingMail);
		transitionBeInTroubleToBeInDanger.setSourceState(beInTrouble);
		transitionBeInTroubleToBeInDanger.setTargetState(beInDanger);
		transitionSendingMailToStopMailing.setSourceState(sendingMail);
		transitionSendingMailToStopMailing.setTargetState(stopMailing);

	}

	/**
	*replyAction
	*/
	protected abstract void replyAction();
	/**
	*denyingAction
	*/
	protected abstract void denyingAction();
	/**
	*throwingPhoneAction
	*/
	protected abstract void throwingPhoneAction();
	/**
	*receivingKnifeAction
	*/
	protected abstract void receivingKnifeAction();
	/**
	*rejectingAction
	*/
	protected abstract void rejectingAction();
	/**
	*isKnifeGoods
	*/
	protected abstract boolean isKnifeGoods(Event e);
}
