 /*
 * UwakiGenbaModel.java
 */
package Uwaki;

import org.boxed_economy.besp.container.BESPContainer;
import org.boxed_economy.besp.container.BESPPlugin;
import org.boxed_economy.besp.model.ModelContainer;
import org.boxed_economy.besp.model.fmfw.AgentType;
import org.boxed_economy.besp.model.fmfw.GoodsType;
import org.boxed_economy.besp.model.fmfw.BehaviorType;
import org.boxed_economy.besp.model.fmfw.RelationType; 

/**
 * Model for Boxed Economy Foundation Model Framework
 *
 * @generated modifiable
 * @version $$Id$$
 */
public class UwakiGenbaModel implements BESPPlugin {
	
	public static AgentType AGENTTYPE_BoyAgent;
	
	public static AgentType AGENTTYPE_GirlAgent;
	public static BehaviorType BEHAVIORTYPE_MailingBehavior;
	
	public static BehaviorType BEHAVIORTYPE_ExcuseBehavior;
	public static BehaviorType BEHAVIORTYPE_DemandBehavior;
	public static RelationType RELATIONTYPE_CoupleRelation;
	
	public static GoodsType GOODSTYPE_KnifeGoods;
	public static GoodsType GOODSTYPE_PhoneGoods;
	
	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	public static void initializePlugin(BESPContainer container) {
		installTypes(container);
		buildStructure(container);
		setPriority(container);
	}

	/** 
	* This method will be modified automatically by Model Editor
	*
	* @generated
	*/
	private static void installTypes(BESPContainer container) {
		//Get the model container  
		ModelContainer modelContainer = container.getModelContainer();
		
		AGENTTYPE_GirlAgent=modelContainer.installAgentType("Uwaki.GirlAgent");
		AGENTTYPE_BoyAgent=modelContainer.installAgentType("Uwaki.BoyAgent");
		BEHAVIORTYPE_DemandBehavior=modelContainer.installBehaviorType("Uwaki.DemandBehavior");
		BEHAVIORTYPE_ExcuseBehavior=modelContainer.installBehaviorType("Uwaki.ExcuseBehavior");
		RELATIONTYPE_CoupleRelation=modelContainer.installRelationType("Uwaki.CoupleRelation");
		GOODSTYPE_KnifeGoods=modelContainer.installGoodsType("Uwaki.KnifeGoods");
		GOODSTYPE_PhoneGoods=modelContainer.installGoodsType("Uwaki.PhoneGoods");
	}

	/** 
	* This method will be modified automatically by Model Editor 
	*
	* @generated
	*/
	private static void buildStructure(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
	}

	/** 
	* Set priority 
	*
	* @generated modifiable
	*/	
	private static void setPriority(BESPContainer container) {
		ModelContainer modelContainer = container.getModelContainer();
		
		//:TODO set priority
	}
}